Attribute VB_Name = "Module1"
Option Explicit

Public Db As Database
Public Rs As Recordset
Public sql As Variant
Public sString As String
Public dbOpened As Boolean

Public nDay() As Integer
Public nMonth() As Integer
Public nYear() As Integer
Public sSaints() As String
Public nRecCount As Integer
Public DatabaseFileName As String



Public Sub Easter()
    sql = "SELECT [Day], [Month],[Year] " _
    & " From EASTER " _
    & " ORDER BY [Year];"
    OpenDbase (sql)
    GetEaster
End Sub

Public Sub Weaster()
sql = "SELECT [Day], [Month],[Year] " _
& "From WEASTER " _
& " ORDER BY [Year];"
    OpenDbase (sql)
    GetEaster
End Sub


Public Sub SaintDate()
sql = "SELECT  [Day], [Month],[sText] " _
& "From SAINT " _
& " ORDER BY [Month], [Day];"
    OpenDbase (sql)
    GetSaints
End Sub


Public Sub Saint()
sql = "SELECT  [Day], [Month],[sText] " _
& "From SAINT " _
& " ORDER BY [sText];"
    OpenDbase (sql)
    GetSaints
End Sub


Public Sub SearchEaster(sYear As String)
    sql = "SELECT [Day], [Month],[Year] " _
    & " From EASTER " & " WHERE Year=" & sYear _
    & " ORDER BY [Year];"
    OpenDbase (sql)
    GetEaster
End Sub

Public Sub SearchWeaster(sYear As String)   'WEASTER
    sql = "SELECT [Day], [Month],[Year] " _
    & " From WEASTER " & " WHERE Year=" & sYear _
    & " ORDER BY [Year];"
    OpenDbase (sql)
    GetEaster
End Sub


Public Sub SearchSaintDate(sDay As String, sMonth As String)
sql = "SELECT [Day], [Month], [sText] " _
& "From SAINT " & " WHERE Day=" & sDay & " " & " AND Month=" & sMonth & " " _
& " ORDER BY [Month], [Day];"
    OpenDbase (sql)
    GetSaints
End Sub


Public Sub SearchSaint(sString As String)
sql = "SELECT [Day], [Month], [sText]  " _
& "From SAINT " & " WHERE LEFT(sText," & Str(Len(sString)) & ") ='" & sString & "'" _
& " ORDER BY [Month],[Day];"
    OpenDbase (sql)
    GetSaints
End Sub




Public Sub CloseDatabase()
    On Error GoTo ErrorTrap
    If dbOpened = True Then
        Rs.Close
    End If
    dbOpened = False
ErrorTrap:
End Sub

Public Sub OpenDbase(sql As Variant)

'    On Error GoTo ErrorTrap
    If dbOpened = True Then
        Rs.Close
        dbOpened = False
    End If

'sql = "SELECT [Day], [Month], [sText]" _
'& "From SAINT " _
'& " ORDER BY [Month], [Day];"

'    Set Db = OpenDatabase("D:\Programs Development\DevStudio\Vb\Orthodox\OrthodoxCalender.mdb")

    Set Db = OpenDatabase("OrthodoxCalender.mdb")


    Set Rs = Db.OpenRecordset(sql, dbOpenDynaset)
     If Rs.RecordCount > 0 Then
     If Not Rs.BOF Then
            Rs.MoveFirst
     End If
     Else
        MsgBox "No matching records found"
     End If
     dbOpened = True
     Exit Sub
     
'ErrorTrap:
'    MsgBox "Error found-> " & Err.Description
'    dbOpened = False
End Sub



Public Sub GetSaints()
    If Rs.RecordCount > 0 Then
        Rs.MoveFirst
        ReDim nDay(0)
        ReDim nMonth(0)
        ReDim sSaints(0)
        While Not Rs.EOF
            ReDim Preserve nDay(UBound(nDay) + 1)
            ReDim Preserve nMonth(UBound(nMonth) + 1)
            ReDim Preserve sSaints(UBound(sSaints) + 1)
            nRecCount = UBound(nDay)
            nDay(UBound(nDay)) = Rs.Fields(0)
            nMonth(UBound(nMonth)) = Rs.Fields(1)
            sSaints(UBound(sSaints)) = Rs.Fields(2)
            Rs.MoveNext
        Wend
    End If
End Sub


Public Sub GetEaster()
    If Rs.RecordCount > 0 Then
        Rs.MoveFirst
        ReDim nDay(0)
        ReDim nMonth(0)
        ReDim nYear(0)
        While Not Rs.EOF
            ReDim Preserve nDay(UBound(nDay) + 1)
            ReDim Preserve nMonth(UBound(nMonth) + 1)
            ReDim Preserve nYear(UBound(nYear) + 1)
            nRecCount = UBound(nDay)
            nDay(UBound(nDay)) = Rs.Fields(0)
            nMonth(UBound(nMonth)) = Rs.Fields(1)
            nYear(UBound(nYear)) = Rs.Fields(2)
            Rs.MoveNext
        Wend
    End If
End Sub

Public Sub LoadCFG()
    Dim filenumber As Integer

    On Error GoTo ErrorTrap
    filenumber = FreeFile
    Open "C:\Orthodox.CFG" For Input As #filenumber
        Line Input #1, DatabaseFileName ' Read line into variable.
    Close #filenumber
    Exit Sub
ErrorTrap:

    FrmMain.CommonDialog1.DialogTitle = "Locate the Orthodox Database (OrthodoxCalender.mdb)"
    FrmMain.CommonDialog1.Filter = "*.mdb"
    FrmMain.CommonDialog1.ShowOpen
    DatabaseFileName = FrmMain.CommonDialog1.filename
    filenumber = FreeFile
    Open "C:\Orthodox.CFG" For Output Shared As #filenumber
        Write #filenumber, DatabaseFileName ' Read line into variable.
    Close #filenumber
    
End Sub
